local addon = LibStub("AceAddon-3.0"):GetAddon("BurlexUID");
local module = addon:NewModule("ActionBars");
----------------------------------------------------------------------------------------------------
local default, plate = {
  popup1 = {anim = 1, alpha = 1, enable = 1},
  popup2 = {anim = 1, alpha = 1, enable = 1},
  bar1 = {alpha = 1, enable = 1},
  bar2 = {alpha = 1, enable = 1},
  bar3 = {alpha = 1, enable = 1},
  bar4 = {alpha = 1, enable = 1},
  bar5 = {alpha = 1, enable = 1},
  bar6 = {alpha = 1, enable = 1},
  bar7 = {alpha = 1, enable = 1},
  bar8 = {alpha = 1, enable = 1},
};
local UpdateSettings = function()
  buidChar.ActionBars = buidChar.ActionBars or {};
  for key,val in pairs(default) do
    if (not buidChar.ActionBars[key]) then buidChar.ActionBars[key] = {}; end
    setmetatable(buidChar.ActionBars[key],{__index = default[key]});
  end
end;
local SetupProfile = function()
  UpdateSettings();
end;
local SetupBartender = function()
  if (not Bartender4) then return; end
  local standard = "BurlexUID Core";
  local settings = { -- actual settings being inserted into our custom profile
    ActionBars = {
      actionbars = { -- following settings are bare minimum, so that anything not defined is retained between resets

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 1
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "LEFT", parent = "BUID_ActionBarPlate", x=-1, y=75, scale = 0.85, growHorizontal="RIGHT"}}, -- 1
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 2
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "LEFT", parent = "BUID_ActionBarPlate", x=-1, y=36, scale = 0.85, growHorizontal="RIGHT"}}, -- 2
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 3
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "LEFT", parent = "BUID_ActionBarPlate", x=-1, y=-4, scale = 0.85, growHorizontal="RIGHT"}}, -- 3
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 4
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "RIGHT", parent = "BUID_ActionBarPlate", x=-402, y=75, scale = 0.85, growHorizontal="RIGHT"}}, -- 4
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 5
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "RIGHT", parent = "BUID_ActionBarPlate", x=-402, y=36, scale = 0.85, growHorizontal="RIGHT"}}, -- 5
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 6
{enabled = true, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "RIGHT", parent = "BUID_ActionBarPlate", x=-402, y=-4, scale = 0.85, growHorizontal="RIGHT"}}, -- 6
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 7
{enabled = true, buttons = 12, rows = 3, padding = 4, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {point = "LEFT", parent = "BUID_ActionBarPlate", x=-138, y=60, scale = 0.80, growHorizontal="RIGHT"}}, -- 7
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Bar 8
{enabled = true, buttons = 12, rows = 3, padding = 4, hidemacrotext = true, hidehotkey = true, showgrid = false,skin = {Zoom = true}, position = {point = "RIGHT", parent = "BUID_ActionBarPlate", x=6, y=60, scale = 0.80, growHorizontal="RIGHT"}}, -- 8
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
{enabled = false, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {parent = "BUID_ActionBarPlate", scale = 0.85, growHorizontal="RIGHT"}}, -- 9
{enabled = false, buttons = 12, rows = 1, padding = 3, hidemacrotext = true, hidehotkey = true, showgrid = false, skin = {Zoom = true}, position = {parent = "BUID_ActionBarPlate", scale = 0.85, growHorizontal="RIGHT"}} -- 10
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      }
    },
    BagBar = { enabled = true, padding = 0, skin = {Zoom = true}, position = {point = "TOPRIGHT", parent = "BUID_ActionBarPlate", x=-6, y=38, scale = 0.80, growHorizontal="LEFT"}, rows = 1, keyring = true, OneBag = false},
    MicroMenu = { enabled = true, padding = -3, skin = {Zoom = true}, position = {point = "TOPLEFT", parent = "BUID_ActionBarPlate", x=603, y=40, scale = 0.80, growHorizontal="RIGHT"}},
    PetBar = { enabled = true, padding = 1, skin = {Zoom = true}, position = {point = "TOPLEFT", parent = "BUID_ActionBarPlate", x=5, y=34, scale = 0.7, growHorizontal="RIGHT"}, rows = 1},
    StanceBar = { enabled = true, padding = 1, skin = {Zoom = true}, position = {point = "TOPRIGHT", parent = "BUID_ActionBarPlate", x=-605, y=38, scale = 0.85, growHorizontal="LEFT"}, rows = 1},
    MultiCast = { enabled = true, position = {point = "TOPRIGHT", parent = "BUID_ActionBarPlate", x=-777, y=36, scale = 0.75}},
    Vehicle = { enabled = false},
    BlizzardArt = { enabled = false},
  };

  local lib = LibStub("LibWindow-1.1",true);
  if not lib then return; end
  function lib.RegisterConfig(frame, storage, names)
    if not lib.windowData[frame] then
      lib.windowData[frame] = {}
    end
    lib.windowData[frame].names = names
    lib.windowData[frame].storage = storage
    local parent = frame:GetParent();
    if (storage.parent) then
      frame:SetParent(storage.parent);
      if storage.parent == "BUID_ActionBarPlate" then
        frame:SetFrameStrata("LOW");
      end
    elseif (parent and parent:GetName() == "BUID_ActionBarPlate") then
      frame:SetParent(UIParent);
    end
  end
  SetupProfile = function() -- apply default settings into a custom BT4 profile
    UpdateSettings();
    if buidChar.ActionBars.Bartender4 then return; end
    Bartender4.db:SetProfile(standard);
    for k,v in LibStub("AceAddon-3.0"):IterateModulesOfAddon(Bartender4) do -- for each module (BagBar, ActionBars, etc..)
      if settings[k] and v.db.profile then
        v.db.profile = module:MergeData(v.db.profile,settings[k])
      end
    end
    Bartender4:UpdateModuleConfigs(); -- run ApplyConfig for all modules, so that the new settings are applied
    buidChar.ActionBars.Bartender4 = true;
  end
  plate:HookScript("OnUpdate",function()
    if (InCombatLockdown()) then return; end
    if (Bartender4.db:GetCurrentProfile() == standard) then
      if Bartender4.Locked then return; end
      addon:Print("The ability to unlock your bars is disabled when using the BurlexUID Default profile in Bartender4. Please change profiles to enable this functionality.");
      Bartender4:Lock();
    end
  end);  
end;

function module:MergeData(target,source)
  if type(target) ~= "table" then target = {} end
  for k,v in pairs(source) do
    if type(v) == "table" then
      target[k] = self:MergeData(target[k], v);
    else
      target[k] = v;
    end
  end
  return target;
end
function module:OnInitialize()
  do -- create bar plate and masks
    plate = CreateFrame("Frame","BUID_ActionBarPlate",BurlexUID,"BUID_ActionBarsTemplate");
    plate:SetFrameStrata("BACKGROUND"); plate:SetFrameLevel(1);
    plate:SetPoint("BOTTOM");
  
    plate.mask1 = CreateFrame("Frame","BUID_Popup1Mask",BurlexUID,"BUID_Popup1MaskTemplate");
    plate.mask1:SetFrameStrata("MEDIUM"); plate.mask1:SetFrameLevel(0);
    plate.mask1:SetPoint("BOTTOM",BUID_Popup1,"BOTTOM");
  
    plate.mask2 = CreateFrame("Frame","BUID_Popup2Mask",BurlexUID,"BUID_Popup2MaskTemplate");
    plate.mask2:SetFrameStrata("MEDIUM"); plate.mask2:SetFrameLevel(0);
    plate.mask2:SetPoint("BOTTOM",BUID_Popup2,"BOTTOM");
  end
  addon.options.args["backdrop"] = {
    name = "ActionBar Backdrops",
    desc = "configure actionbar backdrops",
    type = "group", args = {
      bar1 = {name = "toggle or set the alpha for bar1", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar1; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar1.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar1.enable = 0;
            addon:Print("Backdrop1 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar1.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar1.enable = 1;
            addon:Print("Backdrop1 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar1.alpha = val;
              addon:Print("Backdrop1 Alpha set to "..val);
            end
          end
        end
      },
      bar2 = {name = "toggle or set the alpha for bar2", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar2; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar2.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar2.enable = 0;
            addon:Print("Backdrop2 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar2.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar2.enable = 1;
            addon:Print("Backdrop2 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar2.alpha = val;
              addon:Print("Backdrop2 Alpha set to "..val);
            end
          end
        end
      },
      bar3 = {name = "toggle or set the alpha for bar3", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar3; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar3.enable == 0) or (val == "off") then
            buidChar.ActionBars.bar3.enable = 1;
            addon:Print("Backdrop3 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar3.enable == 1) or (val == "on") then
            buidChar.ActionBars.bar3.enable = 0;
            addon:Print("Backdrop3 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar3.alpha = val;
              addon:Print("Backdrop3 Alpha set to "..val);
            end
          end
        end
      },
      bar4 = {name = "toggle or set the alpha for bar4", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar4; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar4.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar4.enable = 0;
            addon:Print("Backdrop4 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar4.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar4.enable = 1;
            addon:Print("Backdrop4 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar4.alpha = val;
              addon:Print("Backdrop4 Alpha set to "..val);
            end
          end
        end
      },
      bar5 = {name = "toggle or set the alpha for bar5", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar5; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar5.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar5.enable = 0;
            addon:Print("Backdrop5 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar5.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar5.enable = 1;
            addon:Print("Backdrop5 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar5.alpha = val;
              addon:Print("Backdrop5 Alpha set to "..val);
            end
          end
        end
      },
      bar6 = {name = "toggle or set the alpha for bar6", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar6; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar6.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar6.enable = 0;
            addon:Print("Backdrop6 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar6.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar6.enable = 1;
            addon:Print("Backdrop6 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar6.alpha = val;
              addon:Print("Backdrop6 Alpha set to "..val);
            end
          end
        end
      },
      bar7 = {name = "toggle or set the alpha for bar7", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar7; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar7.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar7.enable = 0;
            addon:Print("Backdrop7 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar7.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar7.enable = 1;
            addon:Print("Backdrop7 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar7.alpha = val;
              addon:Print("Backdrop7 Alpha set to "..val);
            end
          end
        end
      },
      bar8 = {name = "toggle or set the alpha for bar8", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.bar8; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.bar8.enable == 1) or (val == "off") then
            buidChar.ActionBars.bar8.enable = 0;
            addon:Print("Backdrop8 Disabled");
          elseif (val == "" and buidChar.ActionBars.bar8.enable == 0) or (val == "on") then
            buidChar.ActionBars.bar8.enable = 1;
            addon:Print("Backdrop8 Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.bar8.alpha = val;
              addon:Print("Backdrop8 Alpha set to "..val);
            end
          end
        end
      },
      popup1 = {name = "toggle or set the alpha for popup1", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.popup1; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.popup1.enable == 1) or (val == "off") then
            buidChar.ActionBars.popup1.enable = 0;
            addon:Print("Popup1 Backdrop Disabled");
          elseif (val == "" and buidChar.ActionBars.popup1.enable == 0) or (val == "on") then
            buidChar.ActionBars.popup1.enable = 1;
            addon:Print("Popup1 Backdrop Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.popup1.alpha = val;
              addon:Print("Popup1 Alpha set to "..val);
            end
          end
        end
      },
      popup2 = {name = "toggle or set the alpha for popup2", type="input",
        get = function(info) return buidChar and buidChar.ActionBars and buidChar.ActionBars.popup2; end,
        set = function(info,val)
          if (val == "" and buidChar.ActionBars.popup2.enable == 1) or (val == "off") then
            buidChar.ActionBars.popup2.enable = 0;
            addon:Print("Popup2 Backdrop Disabled");
          elseif (val == "" and buidChar.ActionBars.popup2.enable == 0) or (val == "on") then
            buidChar.ActionBars.popup2.enable = 1;
            addon:Print("Popup2 Backdrop Enabled");
          else
            val = tonumber(val);
            if (type(val) == "number") then
              buidChar.ActionBars.popup2.alpha = val;
              addon:Print("Popup2 Alpha set to "..val);
          end
        end
      end
    },
      bars = {name = "toggle or set the alpha for all bars", type="input",
        get = function(info) return buidChar and buidChar.ActionBars; end,
        set = function(info,val)
          if (val == "" or val == "on" or val == "off") then
            if (val == "off" or buidChar.ActionBars.bar1.enable == 1) then
              for i = 1,8 do buidChar.ActionBars["bar"..i].enable = 0; end
              addon:Print("Backdrops for All Bars Disabled");
            elseif (val == "on" or buidChar.ActionBars.bar1.enable == 0) then
              for i = 1,8 do buidChar.ActionBars["bar"..i].enable = 1; end
              addon:Print("Backdrops for All Bars Enabled");
            end    
          else
            val = tonumber(val);
            if (type(val) == "number") then
              for i = 1,8 do buidChar.ActionBars["bar"..i].alpha = val; end
              addon:Print("Alpha for All Bar Backdrops set to "..val);
            end
          end
        end
      },
      popups = {name = "toggle or set the alpha for all popups", type="input",
        get = function(info) return buidChar.ActionBars; end,
        set = function(info,val)
          if (val == "" or val == "on" or val == "off") then
            if (val == "off" or buidChar.ActionBars.popup1.enable == 1) then
              for i = 1,2 do buidChar.ActionBars["popup"..i].enable = 0; end
              addon:Print("Backdrops for All Popups Disabled");
            elseif (val == "on" or buidChar.ActionBars.popup1.enable == 0) then
              for i = 1,2 do buidChar.ActionBars["popup"..i].enable = 1; end
              addon:Print("Backdrops for All Popups Enabled");
            end    
          else
            val = tonumber(val);
            if (type(val) == "number") then
              for i = 1,2 do buidChar.ActionBars["popup"..i].alpha = val; end
              addon:Print("Alpha for All Popup Backdrops set to "..val);
            end
          end
        end
      },
      all = {name = "toggle or set the alpha for all backdrops", type="input",
        get = function(info) return buidChar.ActionBars; end,
        set = function(info,val)
          if (val == "" or val == "on" or val == "off") then
            if (val == "off" or buidChar.ActionBars.bar1.enable == 1) then
              for i = 1,8 do buidChar.ActionBars["bar"..i].enable = 0; end
              for i = 1,2 do buidChar.ActionBars["popup"..i].enable = 0; end
              addon:Print("All Backdrops Disabled");
            elseif (val == "on" or buidChar.ActionBars.bar1.enable == 0) then
              for i = 1,8 do buidChar.ActionBars["bar"..i].enable = 1; end
              for i = 1,2 do buidChar.ActionBars["popup"..i].enable = 1; end
              addon:Print("All Backdrops Enabled");
            end    
          else
            val = tonumber(val);
            if (type(val) == "number") then
              for i = 1,8 do buidChar.ActionBars["bar"..i].alpha = val; end
              for i = 1,2 do buidChar.ActionBars["popup"..i].alpha = val; end
              addon:Print("Alpha for All Backdrops set to "..val);
            end
          end
        end
      }
    }
  };
  addon.options.args["resetbars"] = {
    type = "execute",
    name = "Reset ActionBars",
    desc = "resets all ActionBar options to default",
    func = function()
      if (InCombatLockdown()) then 
        addon:Print(ERR_NOT_IN_COMBAT);
      else
        buidChar.ActionBars = {};
        SetupProfile();
        addon:Print("ActionBar Options Reset");
      end
    end
  };

  SetupBartender();  
end
function module:OnEnable()  
  do -- create base module frames
    plate:HookScript("OnUpdate",function() -- backdrop and popup visibility changes (alpha, animation, hide/show)
      if (buidChar.ActionBars) then
        for b = 1,8 do -- for each backdrop
          if buidChar.ActionBars["bar"..b].enable == 1 then -- backdrop enabled
            _G["BUID_Bar"..b]:SetAlpha(buidChar.ActionBars["bar"..b].alpha or 1); -- apply alpha
          else -- backdrop disabled
            _G["BUID_Bar"..b]:SetAlpha(0);
          end
        end
        for p = 1,2 do -- for each popup
          if buidChar.ActionBars["popup"..p].enable == 1 then -- popup enabled
            _G["BUID_Popup"..p]:SetAlpha(buidChar.ActionBars["popup"..p].alpha or 1); -- apply alpha
            if buidChar.ActionBars["popup"..p].anim == 1 then --- animation enabled
              _G["BUID_Popup"..p.."MaskBG"]:SetAlpha(1);
            else -- animation disabled
              _G["BUID_Popup"..p.."MaskBG"]:SetAlpha(0);
            end            
          else -- popup disabled
            _G["BUID_Popup"..p]:SetAlpha(0);
            _G["BUID_Popup"..p.."MaskBG"]:SetAlpha(0);
          end
        end
        if (MouseIsOver(BUID_Popup1Mask)) then -- popup1 animation
          BUID_Popup1MaskBG:Hide();
          BUID_Popup2MaskBG:Show();
        elseif (MouseIsOver(BUID_Popup2Mask)) then -- popup2 animation
          BUID_Popup2MaskBG:Hide();
          BUID_Popup1MaskBG:Show();
        else -- animation at rest
          BUID_Popup1MaskBG:Show();
          BUID_Popup2MaskBG:Show();
        end
      end
    end);
  end
  do -- modify strata / levels of backdrops
    for i = 1,8 do
      _G["BUID_Bar"..i]:SetFrameStrata("BACKGROUND");
      _G["BUID_Bar"..i]:SetFrameLevel(3);
    end
    for i = 1,2 do
      _G["BUID_Popup"..i]:SetFrameStrata("BACKGROUND");
      _G["BUID_Popup"..i]:SetFrameLevel(3);
    end
  end
  SetupProfile();
end
